Index: src/docs/userguide/plugins.xml
===================================================================
--- src/docs/userguide/plugins.xml	(revision 1442)
+++ src/docs/userguide/plugins.xml	(working copy)
@@ -7,7 +7,7 @@
         Gradle belong to the core distribution of Gradle and they are NEVER updated or changed in any way for a
         particular Gradle distribution. If there is a bug in the compile functionality of Gradle, we gonna release a new
         version of Gradle. There is no change of behavior for the lifetime of a given distribution of Gradle. We mention
-        this as there is another build tools with a plugin system which behaves differently.
+        this as there is another build tool with a plugin system which behaves differently.
     </para>
     <section id='sec:using_plugins'>
         <title>Declaring Plugins</title>
Index: src/docs/userguide/logging.xml
===================================================================
--- src/docs/userguide/logging.xml	(revision 1442)
+++ src/docs/userguide/logging.xml	(working copy)
@@ -2,7 +2,7 @@
     <title>Logging</title>
     <para>The log is the main 'UI' of a build tool. If it is too verbose, real warnings and problems are easily hidden
         by this. On the other hand you need the relevant information for figuring out if things have gone wrong. Gradle
-        has added to log-levels to the ones normally used. Those levels are
+        has added two log-levels to the ones normally used. Those levels are
         <emphasis>QUIET</emphasis>
         and <emphasis>LIFECYCLE</emphasis>. The latter is the default and is telling you just what task is getting
         executed or skipped.
@@ -88,8 +88,8 @@
         <title>External Tools and Standard Output</title>
         <para>Gradle uses internally Ant and Ivy a lot. Both have their own logging system. Gradle injects an adapter
             into there logging system to redirect there logging output into the Gradle logging system. There is a 1:1
-            mapping from the Ant/Ivy log levels to the Gradle log levels, except the Ant/Ivy trace level, which is
-            mapped to Gradle debug. This means the default Gradle log level does not show any Ant/Ivy output unless it
+            mapping from the Ant/Ivy log levels to the Gradle log levels, except the Ant/Ivy <emphasis>TRACE</emphasis> level, which is
+            mapped to Gradle <emphasis>DEBUG</emphasis>. This means the default Gradle log level does not show any Ant/Ivy output unless it
             is an error or a warning.
         </para>
         <para>There are many tools out there which still use standard output for logging. Gradle redirects by default
@@ -119,7 +119,7 @@
         <sample id="logging" dir="logging/project1">
             <sourcefile file="build.gradle"/>
         </sample>
-        <para>Strictly speaking, QUIET and LIFECYCLE are no log levels, but they are markers. But logically Gradle
+        <para>Strictly speaking, <emphasis>QUIET</emphasis> and <emphasis>LIFECYCLE</emphasis> are no log levels, but they are markers. But logically Gradle
             treats them as log levels. In a future version of Gradle we want to provide a logger which provides
             additional log methods
             <literal>quiet</literal>
Index: src/docs/userguide/potentialTraps.xml
===================================================================
--- src/docs/userguide/potentialTraps.xml	(revision 1442)
+++ src/docs/userguide/potentialTraps.xml	(working copy)
@@ -2,7 +2,7 @@
     <title>Potential Traps</title>
     <section id='sec:groovy_script_variables'>
         <title>Groovy Script Variables</title>
-        <para>For Gradle users it is important to understand how Groovy deals with script variables. Groovy has to type
+        <para>For Gradle users it is important to understand how Groovy deals with script variables. Groovy has two types
             of script variables. One with a local scope and one with a script wide scope.
         </para>
         <sample id="scope" dir="userguide/tutorial">
Index: src/docs/userguide/overview.xml
===================================================================
--- src/docs/userguide/overview.xml	(revision 1442)
+++ src/docs/userguide/overview.xml	(working copy)
@@ -165,7 +165,7 @@
                     that syntax' syntax in this article is actually the Groovy syntax.
                 </para>
             </footnote>
-            Languages like Python, Groovy or Ruby do a much better Job here. We have chosen Groovy as it offers by far
+            Languages like Python, Groovy or Ruby do a much better job here. We have chosen Groovy as it offers by far
             the highest transparency for Java people. Its base syntax is the same as Java's as well as its type system,
             its package structure other things. Groovy builds a lot on top of that. But on a common ground with Java.
         </para>
Index: src/docs/userguide/organizeBuildLogic.xml
===================================================================
--- src/docs/userguide/organizeBuildLogic.xml	(revision 1442)
+++ src/docs/userguide/organizeBuildLogic.xml	(working copy)
@@ -40,7 +40,7 @@
             <xref linkend='sec:how_to_declare_your_dependencies'/>
             (except project dependencies). There is
             <emphasis>no</emphasis>
-            need to provide a <emphasis>dependency configuration</emphasis>(e.g. <literal>compile</literal>). For
+            need to provide a <emphasis>dependency configuration</emphasis> (e.g. <literal>compile</literal>). For
             multi-project builds dependencies declared in the
             <literal>settings.gradle</literal>
             file of the root project, are available to all build scripts of the sub-projects.