Index: src/docs/userguide/plugins.xml
===================================================================
--- src/docs/userguide/plugins.xml	(revision 1515)
+++ src/docs/userguide/plugins.xml	(working copy)
@@ -129,9 +129,9 @@
             <para>A plugin is only called once for a given project, even if you have multiple
                 <literal>usePlugin()</literal>
                 statements. An additional call after the first call has no effect but doesn't hurt either. This can be
-                important if you use plugins which extends other plugins. For example
+                important if you use plugins which extend other plugins. For example
                 <literal>usePlugin('groovy')</literal>
-                calls also the Java Plugin. We say the Groovy plugin extend the Java plugin. But you might as well
+                calls also the Java Plugin. We say the Groovy plugin extends the Java plugin. But you might as well
                 write:
             </para>
             <programlisting><![CDATA[
Index: src/docs/userguide/buildscripts.xml
===================================================================
--- src/docs/userguide/buildscripts.xml	(revision 1515)
+++ src/docs/userguide/buildscripts.xml	(working copy)
@@ -141,7 +141,7 @@
             </footnote>
         </para>
         <para>The second layer of Ant is its wealth of Ant tasks and types, like <literal>javac</literal>,
-            <literal>copy</literal> or<literal>jar</literal>. For this layer Gradle provides excellent integration
+            <literal>copy</literal> or <literal>jar</literal>. For this layer Gradle provides excellent integration
             simply by relying on Groovy. Groovy is shipped with the fantastic <literal>AntBuilder</literal>. Using Ant
             tasks from Gradle is as convenient and more powerful than using Ant tasks from a
             <filename>build.xml</filename> file. Let's look at an example:
Index: src/docs/userguide/javaPlugin.xml
===================================================================
--- src/docs/userguide/javaPlugin.xml	(revision 1515)
+++ src/docs/userguide/javaPlugin.xml	(working copy)
@@ -696,8 +696,8 @@
             by setting forking to false or set the forkmode to once.
         </para>
         <para>The Test task detects which classes are test classes by inspecting the compiled test classes.
-            By Default it scans all <emphasis>.class</emphasis> files. You can set custom includes / excludes, only those
-            classes will be scanned.Depending on the Test framework used (JUnit / TestNG) the test class detection uses different criteria.
+            By default it scans all <emphasis>.class</emphasis> files. You can set custom includes / excludes, only those
+            classes will be scanned. Depending on the Test framework used (JUnit / TestNG) the test class detection uses different criteria.
         </para>
         <para>
             When using JUnit, we scan for both JUnit 3 and 4 test classes. If any of the following criteria match the
Index: src/docs/userguide/warPlugin.xml
===================================================================
--- src/docs/userguide/warPlugin.xml	(revision 1515)
+++ src/docs/userguide/warPlugin.xml	(working copy)
@@ -37,7 +37,7 @@
             transitively. Let's say you add <literal>commons-httpclient:commons-httpclient:3.0</literal> to any of the
             provided configurations. This dependency has a dependency on <literal>commons-codec</literal>.
             This means neither <literal>httpclient</literal> nor <literal>commons-codec</literal> is added to your
-            WAR, even if <literal>commons-code</literal> were an explicit dependency of your <literal>compile</literal>
+            WAR, even if <literal>commons-codec</literal> were an explicit dependency of your <literal>compile</literal>
             configuration. If you don't want this transitive behavior, simply declare your <literal>provided</literal>
             dependencies like <literal>commons-httpclient:commons-httpclient:3.0@jar</literal>.
         </para>
Index: src/docs/userguide/thisAndThat.xml
===================================================================
--- src/docs/userguide/thisAndThat.xml	(revision 1515)
+++ src/docs/userguide/thisAndThat.xml	(working copy)
@@ -189,7 +189,7 @@
         <title>Accessing the web via a proxy</title>
         <para>Setting a proxy for web access (for example for downloading dependencies) is easy. Gradle does not need to
             provide special functionality for this. The JVM can be instructed to go via proxy by setting certain system
-            properties. You could set this system properties directly in your build script with <literal>
+            properties. You could set these system properties directly in your build script with <literal>
                 System.properties['proxy.proxyUser'] = 'userid'</literal>. An arguably nicer way is shown in
             <xref linkend='sec:gradle_properties_and_system_properties'/>. Your gradle.properties file could look like
             this:
Index: src/docs/userguide/depMngmt.xml
===================================================================
--- src/docs/userguide/depMngmt.xml	(revision 1515)
+++ src/docs/userguide/depMngmt.xml	(working copy)
@@ -24,7 +24,7 @@
                 </para>
             </listitem>
             <listitem>
-                <para>It hopas to be clear what are the first level dependencies and what are the transitive ones. There
+                <para>It hopes to be clear what are the first level dependencies and what are the transitive ones. There
                     are different ways to achieve this. We will look at this later.
                 </para>
             </listitem>
@@ -504,7 +504,7 @@
         </para>
         <itemizedlist>
             <listitem>
-                <para>The IBibilio repository is can be down or has a very long response time.
+                <para>The IBibilio repository can be down or has a very long response time.
                 </para>
             </listitem>
             <listitem>